using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Reflection;

namespace BindingExample
{
    public partial class Form1 : Form
    {
        Table mySequence;

        public Form1()
        {
            InitializeComponent();
            mySequence = new Table();
            MyRow a = new MyRow();
            MyRow b = new MyRow();
            mySequence.Add(a);
            mySequence.Add(b);

            gridDataBoundGrid1.DataSource = mySequence;
            dataGridView1.DataSource = mySequence;
            gridGroupingControl1.DataSource = mySequence;
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            this.Close();
        }
    }

    public class Table : BindingList<MyRow>, ITypedList
    {
        #region ITypedList

        PropertyDescriptorCollection ITypedList.GetItemProperties(PropertyDescriptor[] listAccessors)
        {
            List<PropertyDescriptor> myList = new List<PropertyDescriptor>();

            PropertyDescriptorCollection myColl = TypeDescriptor.GetProperties(typeof(MyRow));
            foreach (PropertyDescriptor currDescr in myColl)
            {
                myList.Add(currDescr);
            }

            PropertyDescriptorCollection pdc = new PropertyDescriptorCollection(myList.ToArray());
            return pdc;
        }

        string ITypedList.GetListName(PropertyDescriptor[] listAccessors)
        {
            return "TableList";
        }

        #endregion
    }

    public class MyRow
    {
        private string m_Name;
        private string m_Type;

        public MyRow()
        {
            m_MyExample = new Test();
        }

        private Test m_MyExample;

        public Test MyExample
        {
            get { return m_MyExample; }
            set { m_MyExample = value; }
        }

        public string Name
        {
            get { return m_Name; }
            set { m_Name = value; }
        }

        public string Type
        {
            get { return m_Type; }
            set { m_Type = value; }
        }
    }

    public class Test
    {
        private int myVar;

        public int MyProperty
        {
            get { return myVar; }
            set { myVar = value; }
        }

        public override string ToString()
        {
            return "Example";
        }
	
    }

}